//========================================
// ClientGtk.C
//
// Create a nibbles world client with a Gtk 
// interface.
//
// ZNibbles
// Vincent Mallet 1999
//========================================

// $Id: ClientGtk.C,v 1.2 1999/04/23 16:47:47 vmallet Exp $

/* ZNibbles - a small multiplayer game
 * Copyright (C) 1997, 1998, 1999 Vincent Mallet - vmallet@enst.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "gtk/gtk.h"

#include "World.H"
#include "GtkInterface.H"


int main(int argc, char **argv)
{
  World world;                 // create the world (client side)
  GtkInterface gif(world);     // create a Gtk interface

  world.set_interface(&gif);   // plug interface into world
  
  gtk_init(&argc, &argv);      // initialize Gtk
   
  world.init(argc, argv);      // initialize world & interface

  world.run();                 // start the client

  cout << "Yeah !\n" << endl;
  return 0;
}

